"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _templateObject = _taggedTemplateLiteral(["\n", ""], ["\n", ""]);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _theme = require("../theme");

var _reactFontawesome = require("@fortawesome/react-fontawesome");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } /* eslint-disable */
// Modules


// Styles


// Icons


var SetBackgroundAndColor = function SetBackgroundAndColor(theme, outline, borderColor, borderHoverColor, backgroundColor, backgroundHoverColor, fontColor, fontHoverColor, underlineOnHover) {
    if (outline) {
        return "\n            border: 1px solid " + theme.colors[borderColor || backgroundColor] + ";\n            background-color: " + theme.colors.none + ";\n            color: " + theme.colors[fontColor || backgroundColor] + ";\n\n            &:hover {\n                &:not(:disabled) {\n                    border: 1px solid " + theme.colors[borderHoverColor || backgroundColor] + ";\n                    background-color: " + theme.colors[backgroundHoverColor || backgroundColor] + ";\n                    color: " + theme.colors[fontHoverColor || 'white'] + "; \n                }\n            }\n    ";
    }
    fontColor = fontColor && fontColor || backgroundColor === "white" && 'blueGrey2' || 'white';

    return "\n        background-color: " + theme.colors[backgroundColor] + ";\n        color: " + theme.colors[fontColor] + ";\n        border: 1px solid " + theme.colors[borderColor || 'none'] + ";\n        &:hover {\n            &:not(:disabled) {\n                " + (backgroundHoverColor ? "background-color: " + theme.colors[backgroundHoverColor] : backgroundColor.indexOf('blue') > -1 ? "background-color: " + theme.colors.blue3 : 'opacity: 0.89;') + "\n\n                " + (underlineOnHover ? 'text-decoration: underline;' : '') + "\n                border: 1px solid " + theme.colors[borderHoverColor || 'none'] + ";\n\n                " + (fontHoverColor ? "color: " + theme.colors[fontHoverColor] + ";" : "") + "\n            }\n        }\n        \n        &:active {\n            &:not(:disabled) {\n                " + (backgroundHoverColor ? "background-color: " + LightenDarkenColor(theme.colors[backgroundHoverColor], -40) : backgroundColor.indexOf('blue') > -1 ? "background-color: " + theme.colors.blue1 : "background-color: " + (backgroundColor && LightenDarkenColor(theme.colors[backgroundColor], -40))) + "\n            }\n        }\n\n    ";
};

var LightenDarkenColor = function LightenDarkenColor(col, amt) {
    var usePound = false;

    if (col[0] === "#") {
        col = col.slice(1);
        usePound = true;
    }

    var num = parseInt(col, 16);
    var r = (num >> 16) + amt;
    if (r > 255) r = 255;else if (r < 0) r = 0;

    var b = (num >> 8 & 0x00FF) + amt;
    if (b > 255) b = 255;else if (b < 0) b = 0;

    var g = (num & 0x0000FF) + amt;
    if (g > 255) g = 255;else if (g < 0) g = 0;

    return (usePound ? "#" : "") + (g | b << 8 | r << 16).toString(16);
};

var SetSizeButton = function SetSizeButton(size, theme) {
    switch (size) {
        case 'px40':
            return "\n                    padding: " + theme.spacing.px12 + " " + theme.spacing.px40 + ";\n                ";
        case 'px30':
            return "\n                padding: " + theme.spacing.px12 + " " + theme.spacing.px30 + ";\n            ";
        case 'px20':
            return "\n                    padding: " + theme.spacing.px12 + " " + theme.spacing.px20 + ";\n                ";
        case 'px16':
            return "\n                padding: " + theme.spacing.px12 + " " + theme.spacing.px16 + ";\n                            ";
        case 'px15':
            return "\n                    padding: " + theme.spacing.px12 + " " + theme.spacing.px15 + ";\n                                        ";
        case 'px10':
            return "\n                    padding: " + theme.spacing.px10 + " " + theme.spacing.px20 + ";\n                ";
        case 'px5':
            return "\n                padding: " + theme.spacing.px5 + " " + theme.spacing.px10 + ";\n            ";
        default:
            return "";
    }
};

var ButtonStyle = (0, _styledComponents2.default)('button')(_templateObject, function (_ref) {
    var theme = _ref.theme,
        block = _ref.block,
        rounded = _ref.rounded,
        size = _ref.size,
        fontSize = _ref.fontSize,
        outline = _ref.outline,
        backgroundColor = _ref.backgroundColor,
        borderColor = _ref.borderColor,
        borderHoverColor = _ref.borderHoverColor,
        backgroundHoverColor = _ref.backgroundHoverColor,
        fontColor = _ref.fontColor,
        fontHoverColor = _ref.fontHoverColor,
        underlineOnHover = _ref.underlineOnHover;
    return "\n    text-align: center;\n    outline: none;\n    border: none;\n    line-height: 1;\n    transition: all 0.3s;\n    margin-right: " + theme.spacing.px15 + ";\n    white-space: nowrap;\n    width: " + (block ? theme.spacing.full : 'initial') + ";\n    border-radius: " + theme.rounded[rounded] + ";\n    font-size: " + theme.fontSize[fontSize] + ";\n    " + SetBackgroundAndColor(theme, outline, borderColor, borderHoverColor, backgroundColor, backgroundHoverColor, fontColor, fontHoverColor, underlineOnHover) + ";\n    " + SetSizeButton(size, theme) + ";\n    position: relative;\n    top: 0;\n    transition: all 0.3s;\n    cursor: pointer;\n    &:disabled {\n        opacity: 0.5;\n        cursor: not-allowed;\n    }\n    &:active {\n        top: 0;\n        box-shadow: 0 0 0 " + theme.colors.active[backgroundColor] + ";\n    }\n    &:last-child {\n        margin-right: " + theme.spacing.none + ";\n    }\n    & > span {\n        // display: flex;\n        justify-content: space-between;\n        align-items: center;\n    }\n    \n    svg {\n        margin: 0 " + theme.spacing.px10 + " 0 0;\n    }\n    \n";
});

var Button = function Button(_ref2) {
    var children = _ref2.children,
        type = _ref2.type,
        fontColor = _ref2.fontColor,
        fontHoverColor = _ref2.fontHoverColor,
        icon = _ref2.icon,
        backgroundColor = _ref2.backgroundColor,
        backgroundHoverColor = _ref2.backgroundHoverColor,
        borderColor = _ref2.borderColor,
        borderHoverColor = _ref2.borderHoverColor,
        underlineOnHover = _ref2.underlineOnHover,
        outline = _ref2.outline,
        size = _ref2.size,
        fontSize = _ref2.fontSize,
        rounded = _ref2.rounded,
        block = _ref2.block,
        disabled = _ref2.disabled,
        onClick = _ref2.onClick,
        innerRef = _ref2.innerRef;

    return _react2.default.createElement(
        _styledComponents.ThemeProvider,
        { theme: _theme.theme },
        _react2.default.createElement(
            ButtonStyle,
            {
                type: type,
                backgroundColor: backgroundColor,
                backgroundHoverColor: backgroundHoverColor,
                borderColor: borderColor,
                borderHoverColor: borderHoverColor,
                fontColor: fontColor,
                underlineOnHover: underlineOnHover,
                fontHoverColor: fontHoverColor,
                outline: outline,
                size: size,
                fontSize: fontSize,
                rounded: rounded,
                block: block,
                onClick: onClick,
                disabled: disabled,
                ref: innerRef,
                id: "button"
            },
            _react2.default.createElement(
                "span",
                null,
                !!icon && _react2.default.createElement(_reactFontawesome.FontAwesomeIcon, { icon: icon, "data-testid": "buttonIcon" }),
                children
            )
        )
    );
};

Button.propTypes = {
    type: _propTypes2.default.string,
    fontColor: _propTypes2.default.string,
    outline: _propTypes2.default.bool,
    size: _propTypes2.default.string,
    rounded: _propTypes2.default.string,
    block: _propTypes2.default.bool,
    disabled: _propTypes2.default.bool,
    onClick: _propTypes2.default.func
};

Button.defaultProps = {
    type: 'button',
    backgroundColor: 'blueGrey2',
    outline: false,
    size: 'px40',
    rounded: 'px10',
    fontSize: 'px14',
    block: false,
    disabled: false,
    onClick: function onClick() {}
};

exports.default = Button;