'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactFontawesome = require('@fortawesome/react-fontawesome');

var _freeSolidSvgIcons = require('@fortawesome/free-solid-svg-icons');

var _theme = require('../theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles

// Icons


var ButtonStyle = (0, _styledComponents2.default)('button')(_templateObject, function (_ref) {
  var theme = _ref.theme,
      showButton = _ref.showButton,
      styleguide = _ref.styleguide;
  return '\n    position: ' + (styleguide ? 'static' : 'absolute') + ';\n    right: ' + theme.spacing.px15 + ';\n    top: ' + theme.spacing.px25 + ';\n    z-index: 9999;\n    border: none;\n    background: none;\n    padding: ' + theme.spacing.none + ';\n    font-size: ' + theme.fontSize.px25 + ';\n    cursor: pointer;\n    outline: none;\n    opacity: 1;\n    transition: all 0.5s;\n    width: ' + theme.spacing.px30 + ';\n    ' + (!showButton ? '\n        display: none;\n        ' : '') + '\n';
});

var ButtonClose = function ButtonClose(_ref2) {
  var onClick = _ref2.onClick,
      showButton = _ref2.showButton,
      styleguide = _ref2.styleguide,
      iconClose = _ref2.iconClose;
  return _react2.default.createElement(
    _styledComponents.ThemeProvider,
    { theme: _theme.theme },
    _react2.default.createElement(
      ButtonStyle,
      {
        onClick: onClick,
        showButton: showButton,
        styleguide: styleguide,
        id: 'buttonClose'
      },
      _react2.default.createElement(_reactFontawesome.FontAwesomeIcon, { icon: iconClose || _freeSolidSvgIcons.faTimes, 'data-testid': 'svg' })
    )
  );
};

ButtonClose.propTypes = {
  onClick: _propTypes2.default.func,
  showButton: _propTypes2.default.bool,
  styleguide: _propTypes2.default.bool,
  iconClose: _propTypes2.default.array
};

ButtonClose.defaultProps = {
  onClick: function onClick() {},
  showButton: true,
  styleguide: false
};

exports.default = ButtonClose;