'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactFontawesome = require('@fortawesome/react-fontawesome');

var _freeSolidSvgIcons = require('@fortawesome/free-solid-svg-icons');

var _reactRouterDom = require('react-router-dom');

var _theme = require('../theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles

// Components


var ButtonIconWrapper = (0, _styledComponents2.default)('button')(_templateObject, function (_ref) {
  var theme = _ref.theme,
      opened = _ref.opened;
  return '\n    margin-right: ' + theme.spacing.px16 + ';\n    padding: 0;\n    background: transparent;\n    border-radius: ' + theme.rounded.px10 + ';\n    color: ' + theme.colors.grey3 + ';\n    border: none;\n    outline: none;\n    cursor: pointer;\n    display: inline-flex;\n    text-align: center;\n    ' + (opened === 1 ? '\n            z-index: 1001; \n            background-color: white;\n        ' : '\n            &:hover {\n                background: none;\n            }\n        ') + '\n';
});

var LinkIconWrapper = (0, _styledComponents2.default)(_reactRouterDom.Link)(_templateObject, function (_ref2) {
  var theme = _ref2.theme,
      opened = _ref2.opened;
  return '\n    margin-left: ' + theme.spacing.px5 + ';\n    padding: ' + theme.spacing.px8 + ';\n    background: ' + theme.colors.grey7 + ';\n    border-radius: ' + theme.rounded.px10 + ';\n    color: ' + theme.colors.grey3 + ';\n    outline: none;\n    cursor: pointer;\n    text-align: center;\n    ' + (opened === 1 ? '\n            z-index: 1001; \n            background-color: white;\n        ' : '\n            &:hover {\n                background: ' + theme.colors.grey6 + ';\n            }\n        ') + '\n';
});

var CustomIcon = (0, _styledComponents2.default)(_reactFontawesome.FontAwesomeIcon)(_templateObject, function (_ref3) {
  var theme = _ref3.theme,
      color = _ref3.color;
  return '\n    font-size: ' + theme.fontSize.px18 + ';\n    color: ' + (color ? theme.colors[color] : theme.colors.blueGrey3) + ';\n';
});

var ButtonIcon = function ButtonIcon(_ref4) {
  var to = _ref4.to,
      onClick = _ref4.onClick,
      icon = _ref4.icon,
      opened = _ref4.opened,
      id = _ref4.id,
      children = _ref4.children,
      color = _ref4.color;
  return _react2.default.createElement(
    _styledComponents.ThemeProvider,
    { theme: _theme.theme },
    to ? _react2.default.createElement(
      LinkIconWrapper,
      {
        opened: opened ? 1 : 0,
        to: to,
        onClick: onClick,
        id: id
      },
      _react2.default.createElement(CustomIcon, { color: color, icon: icon }),
      children || null
    ) : _react2.default.createElement(
      ButtonIconWrapper,
      {
        opened: opened ? 1 : 0,
        onClick: onClick,
        id: id
      },
      _react2.default.createElement(CustomIcon, { color: color, icon: icon }),
      children || null
    )
  );
};

ButtonIcon.propTypes = {
  opened: _propTypes2.default.bool
};

ButtonIcon.defaultProps = {
  opened: false,
  icon: _freeSolidSvgIcons.faLayerGroup
};

exports.default = ButtonIcon;