'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']),
    _templateObject2 = _taggedTemplateLiteral([''], ['']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactFontawesome = require('@fortawesome/react-fontawesome');

var _freeSolidSvgIcons = require('@fortawesome/free-solid-svg-icons');

var _theme = require('../theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles

// Components


var CustomCheckbox = (0, _styledComponents2.default)('div')(_templateObject, function (_ref) {
  var theme = _ref.theme,
      color = _ref.color,
      checked = _ref.checked;
  return '\n        display: block;\n        align-self: center;\n        width: 18px;\n        min-width: 18px;\n        height: 18px;\n        border-radius: 3px;\n        ' + (checked ? 'border: 1.5px solid ' + theme.colors[color] + ';' : 'border: 1.5px solid ' + theme.colors.grey2 + ';') + '\n        position: relative;\n';
});

var InputCheckbox = (0, _styledComponents2.default)('input')(_templateObject, function (_ref2) {
  var theme = _ref2.theme,
      color = _ref2.color;
  return '\n    cursor: pointer;\n    min-width: 18px;\n    max-width: 18px;\n    width: 18px;\n    min-height: 18px;\n    max-height: 18px;\n    height: 18px;\n    appearance: none !important;\n    outline: none;\n    position: absolute;\n    left: 0;\n    right: 0;\n    top: 0;\n    bottom: 0;\n    margin: 0;\n    opacity: 0;\n    & + span {\n        display: none;\n    }\n    &:checked {\n        & + span {\n            display: flex;\n            align-items: center;\n            justify-content: center;\n            background: ' + theme.colors[color] + ';\n            width: 18px;\n            height: 18px;\n            svg {\n                color: ' + theme.colors.white + ';\n            }\n        }\n    }\n';
});

var IconCheckbox = (0, _styledComponents2.default)('span')(_templateObject2);

var Checkbox = function Checkbox(_ref3) {
  var type = _ref3.type,
      name = _ref3.name,
      id = _ref3.id,
      color = _ref3.color,
      onClick = _ref3.onClick,
      rest = _ref3.rest,
      checked = _ref3.checked,
      iconCheck = _ref3.iconCheck,
      dataTestId = _ref3.dataTestId;
  return _react2.default.createElement(
    _styledComponents.ThemeProvider,
    { theme: _theme.theme },
    _react2.default.createElement(
      CustomCheckbox,
      { color: color, checked: checked },
      _react2.default.createElement(InputCheckbox, _extends({
        type: type,
        name: name,
        'data-testid': dataTestId,
        id: id,
        onChange: onClick,
        checked: checked,
        color: color
      }, rest)),
      _react2.default.createElement(
        IconCheckbox,
        null,
        _react2.default.createElement(_reactFontawesome.FontAwesomeIcon, { icon: iconCheck || _freeSolidSvgIcons.faCheck })
      )
    )
  );
};

Checkbox.propTypes = {
  type: _propTypes2.default.string,
  name: _propTypes2.default.node,
  id: _propTypes2.default.node,
  color: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  checked: _propTypes2.default.bool,
  dataTestId: _propTypes2.default.string
};

Checkbox.defaultProps = {
  type: 'checkbox',
  color: 'blue3',
  onClick: function onClick() {},
  checked: false,
  dataTestId: 'checkbox'
};

exports.default = Checkbox;