'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _theme = require('../theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles


var ContainerWrapper = (0, _styledComponents2.default)('div')(_templateObject, function (_ref) {
  var theme = _ref.theme;
  return '\n    display: flex;\n    justify-content: space-between;\n    width: ' + theme.spacing.full + ';\n';
});

var ContainerItem = (0, _styledComponents2.default)('div')(_templateObject, function (_ref2) {
  var theme = _ref2.theme,
      noLeft = _ref2.noLeft,
      spacingDefault = _ref2.spacingDefault,
      maxWidth = _ref2.maxWidth;
  return '\n    padding: ' + (theme.spacing.none + ' ' + theme.spacing.px30 + ' ' + theme.spacing.none + ' ' + (noLeft ? theme.spacing.none : theme.spacing.px30)) + ';\n    width: ' + theme.spacing.full + ';\n    max-width: ' + maxWidth + ';\n    box-sizing: border-box;\n    @media screen and (max-width: ' + theme.breakpoint.xl + ') {\n        padding: ' + (theme.spacing.none + ' ' + theme.spacing.px30 + ' ' + theme.spacing.none + ' ' + (noLeft && !spacingDefault ? theme.spacing.none : theme.spacing.px30)) + ';\n    }\n    @media screen and (max-width: ' + theme.breakpoint.md + ') {\n        padding: ' + (theme.spacing.none + ' ' + theme.spacing.px30 + ' ' + theme.spacing.none + ' ' + (noLeft ? theme.spacing.px30 : theme.spacing.px30)) + ';\n    }\n';
});

var Container = function Container(_ref3) {
  var children = _ref3.children,
      noLeft = _ref3.noLeft,
      spacingDefault = _ref3.spacingDefault,
      maxWidth = _ref3.maxWidth;
  return _react2.default.createElement(
    _styledComponents.ThemeProvider,
    { theme: _theme.theme },
    _react2.default.createElement(
      ContainerWrapper,
      null,
      _react2.default.createElement(
        ContainerItem,
        { 'data-testid': 'container', noLeft: noLeft, maxWidth: maxWidth, spacingDefault: spacingDefault },
        children
      )
    )
  );
};

Container.propTypes = {
  children: _propTypes2.default.node,
  noLeft: _propTypes2.default.bool,
  spacingDefault: _propTypes2.default.bool,
  maxWidth: _propTypes2.default.string
};

Container.defaultProps = {
  children: '',
  noLeft: false,
  spacingDefault: false
};

exports.default = Container;