'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _theme = require('../theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles


var CounterBallWrapper = (0, _styledComponents2.default)('div')(_templateObject, function (_ref) {
  var theme = _ref.theme,
      moreThanTen = _ref.moreThanTen,
      alignTop = _ref.alignTop,
      backgroundColor = _ref.backgroundColor,
      fontColor = _ref.fontColor;
  return '\n    display: inline-flex;\n    position: relative;\n    span {\n        font-size: ' + theme.fontSize.px11 + ';\n        color: ' + (fontColor ? theme.colors[fontColor] : theme.colors.white) + ';\n        background: ' + (backgroundColor ? theme.colors[backgroundColor] : theme.colors.blueGrey3) + ';\n        border-radius: 10px;\n        padding: 2px 6px 3px;\n        margin: 0 1px;\n    }\n    span:nth-child(2) {\n        background: #187db5;\n    }\n    ' + (alignTop ? '\n            top: -13px;\n        ' : '') + '\n    ' + (moreThanTen ? 'span:nth-child(1) {\n            padding: 2px 4px 3px;\n        }' : '') + '\n';
});

var CounterBall = function CounterBall(_ref2) {
  var backgroundColor = _ref2.backgroundColor,
      fontColor = _ref2.fontColor,
      counter = _ref2.counter,
      alignTop = _ref2.alignTop;
  return _react2.default.createElement(
    _styledComponents.ThemeProvider,
    { theme: _theme.theme },
    _react2.default.createElement(
      CounterBallWrapper,
      { moreThanTen: counter > 10, backgroundColor: backgroundColor, fontColor: fontColor, alignTop: alignTop },
      _react2.default.createElement(
        'span',
        null,
        counter
      )
    )
  );
};

CounterBall.propTypes = {
  backgroundColor: _propTypes2.default.string,
  fontColor: _propTypes2.default.string,
  counter: _propTypes2.default.number,
  alignTop: _propTypes2.default.bool
};

CounterBall.defaultProps = {
  backgroundColor: '',
  fontColor: '',
  counter: 0,
  alignTop: false
};

exports.default = CounterBall;