'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']),
    _templateObject2 = _taggedTemplateLiteral([''], ['']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _theme = require('../theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles


var NoContent = (0, _styledComponents2.default)('div')(_templateObject, function (_ref) {
  var theme = _ref.theme;
  return '\n    color: ' + theme.colors.blueGrey3 + ';\n    margin-top: ' + theme.spacing.px25 + ';\n';
});

var StrongParagraph = (0, _styledComponents2.default)('strong')(_templateObject2);

var EmptyContent = function EmptyContent(_ref2) {
  var title = _ref2.title,
      message = _ref2.message;
  return _react2.default.createElement(
    _styledComponents.ThemeProvider,
    { theme: _theme.theme },
    _react2.default.createElement(
      NoContent,
      null,
      title ? _react2.default.createElement(
        StrongParagraph,
        null,
        title
      ) : null,
      message
    )
  );
};

EmptyContent.propTypes = {
  title: _propTypes2.default.string,
  message: _propTypes2.default.string
};

EmptyContent.defaultProps = {
  title: '',
  message: ''
};

exports.default = EmptyContent;