'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _theme = require('../theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles


var FormControlWrapper = (0, _styledComponents2.default)('div')(_templateObject, function (_ref) {
    var theme = _ref.theme,
        inline = _ref.inline;
    return '\n    display: block;\n    width: ' + theme.spacing.full + ';\n    margin-bottom: ' + theme.spacing.px15 + ';\n    ' + (inline ? '\n        display: flex;\n        justify-content: flex-start;\n        align-items: center;\n        @media screen and (max-width: 500px) {\n            display: block;\n            label {\n                margin-bottom: ' + theme.spacing.px10 + ';\n            }\n        }\n        ' : '\n        label {\n            display: block;\n            margin-bottom: ' + theme.spacing.px5 + ';\n        }\n        ') + '\n';
});

var FormControl = function FormControl(_ref2) {
    var inline = _ref2.inline,
        children = _ref2.children;
    return _react2.default.createElement(
        _styledComponents.ThemeProvider,
        { theme: _theme.theme },
        _react2.default.createElement(
            FormControlWrapper,
            { inline: inline },
            children
        )
    );
};

FormControl.propTypes = {
    children: _propTypes2.default.node
};

exports.default = FormControl;