'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _theme = require('../theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles


var ImageStyled = (0, _styledComponents2.default)('img')(_templateObject, function (_ref) {
    var theme = _ref.theme,
        logo = _ref.logo;
    return '\n    display: block;\n    max-width: ' + theme.spacing.full + ';\n    ' + (logo ? '\n            max-height: ' + theme.spacing.px40 + ';\n            max-width: ' + theme.spacing.full + ';\n        ' : "") + '\n';
});

var Image = function Image(_ref2) {
    var src = _ref2.src,
        alt = _ref2.alt,
        logo = _ref2.logo,
        id = _ref2.id;
    return _react2.default.createElement(
        _styledComponents.ThemeProvider,
        { theme: _theme.theme },
        _react2.default.createElement(ImageStyled, { src: src, alt: alt, title: alt, logo: logo, id: id })
    );
};

Image.propTypes = {
    src: _propTypes2.default.string,
    alt: _propTypes2.default.string,
    logo: _propTypes2.default.bool
};

Image.defaultProps = {
    src: '',
    alt: "Descrição da imagem",
    logo: false
};

exports.default = Image;