'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _theme = require('../theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles


var InputStyled = (0, _styledComponents2.default)('input')(_templateObject, function (_ref) {
    var theme = _ref.theme,
        withoutBorder = _ref.withoutBorder,
        disabled = _ref.disabled;
    return '\n    border: 1px solid ' + theme.colors.grey2 + ';\n    border-radius: ' + theme.rounded.px10 + ';\n    color: ' + theme.colors.grey2 + ';\n    font-weight: ' + theme.fontWeight.light + ';\n    padding: ' + theme.spacing.px10 + ' ' + theme.spacing.px15 + ';\n    background: ' + theme.colors.white + ';\n    width: ' + theme.spacing.full + ';\n    box-sizing: border-box;\n    outline: none;\n    ' + (!!withoutBorder ? '\n        border: none;\n        ' : '') + '\n    ' + (!!disabled ? '\n        background: ' + theme.colors.grey7 + ';\n        cursor: not-allowed;\n        ' : '') + '\n';
});

var Input = function Input(_ref2) {
    var type = _ref2.type,
        id = _ref2.id,
        name = _ref2.name,
        block = _ref2.block,
        disabled = _ref2.disabled,
        placeholder = _ref2.placeholder,
        value = _ref2.value,
        withoutBorder = _ref2.withoutBorder,
        onBlur = _ref2.onBlur,
        onFocus = _ref2.onFocus,
        onKeyUp = _ref2.onKeyUp,
        onChange = _ref2.onChange;

    return _react2.default.createElement(
        _styledComponents.ThemeProvider,
        { theme: _theme.theme },
        _react2.default.createElement(InputStyled, {
            type: type,
            id: id,
            name: name,
            block: block,
            disabled: disabled,
            placeholder: placeholder,
            value: value,
            withoutBorder: withoutBorder,
            onBlur: onBlur,
            onFocus: onFocus,
            onKeyUp: onKeyUp,
            onChange: onChange
        })
    );
};

Input.propTypes = {
    type: _propTypes2.default.string,
    name: _propTypes2.default.string,
    block: _propTypes2.default.bool,
    disabled: _propTypes2.default.bool,
    placeholder: _propTypes2.default.string,
    withoutBorder: _propTypes2.default.bool,
    onBlur: _propTypes2.default.func,
    onFocus: _propTypes2.default.func,
    onKeyUp: _propTypes2.default.func,
    onChange: _propTypes2.default.func
};

Input.defaultProps = {
    type: 'text',
    block: false,
    disabled: false,
    placeholder: '',
    withoutBorder: false,
    onBlur: function onBlur() {},
    onFocus: function onFocus() {},
    onKeyUp: function onKeyUp() {},
    onChange: function onChange() {}
};

exports.default = Input;