'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _theme = require('../theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles


var LabelStyled = (0, _styledComponents2.default)('label')(_templateObject, function (_ref) {
    var theme = _ref.theme,
        leftSpace = _ref.leftSpace;
    return '\n    display: block;\n    box-sizing: border-box;\n    font-size: ' + theme.fontSize.px14 + ';\n    color: ' + theme.colors.grey1 + ';\n    align-self: center;\n    ' + (!!leftSpace ? '\n        padding-left: ' + theme.spacing.px5 + ';\n        ' : '\n        padding-right: ' + theme.spacing.px5 + ';\n        ') + '\n';
});

var Label = function Label(_ref2) {
    var children = _ref2.children,
        leftSpace = _ref2.leftSpace,
        htmlFor = _ref2.htmlFor;
    return _react2.default.createElement(
        _styledComponents.ThemeProvider,
        { theme: _theme.theme },
        _react2.default.createElement(
            LabelStyled,
            { leftSpace: leftSpace, htmlFor: htmlFor },
            children
        )
    );
};

Label.propTypes = {
    children: _propTypes2.default.node,
    leftSpace: _propTypes2.default.bool
};

exports.default = Label;