'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _theme = require('../theme');

var _Image = require('../Image/Image');

var _Image2 = _interopRequireDefault(_Image);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles


// Components


var LoadingStyled = (0, _styledComponents2.default)('div')(_templateObject, function (_ref) {
    var theme = _ref.theme;
    return '\n    width: ' + theme.spacing.full + ';\n    height: ' + theme.spacing.full + ';\n    position: fixed;\n    background: rgba(255, 255, 255, 0.85);\n    left: 0;\n    right: 0;\n    top: 0;\n    bottom: 0;\n    z-index: 100000;\n    display: flex;\n    justify-content: center;\n    align-items: center;\n';
});

var Loading = function Loading(_ref2) {
    var isLoading = _ref2.isLoading,
        image = _ref2.image;
    return isLoading ? _react2.default.createElement(
        _styledComponents.ThemeProvider,
        { theme: _theme.theme },
        _react2.default.createElement(
            LoadingStyled,
            null,
            _react2.default.createElement(_Image2.default, { src: image, alt: 'Loading' })
        )
    ) : null;
};

Loading.propTypes = {
    image: _propTypes2.default.string,
    isLoading: _propTypes2.default.bool
};

Loading.defaultProps = {
    image: '#',
    isLoading: false
};

exports.default = Loading;