'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _theme = require('../theme');

var _Image = require('../Image/Image');

var _Image2 = _interopRequireDefault(_Image);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles


// Components


var LoadingStyled = (0, _styledComponents2.default)('div')(_templateObject, function (_ref) {
  var theme = _ref.theme,
      centerIcon = _ref.centerIcon;
  return '\n    width: ' + theme.spacing.full + ';\n    display: flex;\n    justify-content: ' + (centerIcon ? 'center' : 'flex-start') + ';\n    align-items: center;\n    & > img {\n        width: ' + theme.spacing.px90 + ';\n        height: ' + theme.spacing.px90 + ';\n    }\n';
});

var LocalLoading = function LocalLoading(_ref2) {
  var isLoading = _ref2.isLoading,
      centerIcon = _ref2.centerIcon;
  return isLoading ? _react2.default.createElement(
    _styledComponents.ThemeProvider,
    { theme: _theme.theme },
    _react2.default.createElement(
      LoadingStyled,
      { centerIcon: centerIcon, 'data-testid': 'localLoading' },
      _react2.default.createElement(_Image2.default, { src: 'https://bornlogic.gerentesdigitais.com/static/media/loading.98a1a0b7.svg', alt: 'Loading' })
    )
  ) : null;
};

LocalLoading.propTypes = {
  isLoading: _propTypes2.default.bool,
  centerIcon: _propTypes2.default.bool
};

LocalLoading.defaultProps = {
  isLoading: false,
  centerIcon: false
};

exports.default = LocalLoading;