'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _templateObject = _taggedTemplateLiteral(['\n    display: block;\n'], ['\n    display: block;\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n', '\n'], ['\n', '\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n', ''], ['\n', '']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _theme = require('../theme');

var _reactModal = require('react-modal');

var _reactModal2 = _interopRequireDefault(_reactModal);

var _Title = require('../Title/Title');

var _Title2 = _interopRequireDefault(_Title);

var _Button = require('../Button/Button');

var _Button2 = _interopRequireDefault(_Button);

var _ButtonClose = require('../ButtonClose/ButtonClose');

var _ButtonClose2 = _interopRequireDefault(_ButtonClose);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles


// Components


var ModalWrapper = (0, _styledComponents2.default)('div')(_templateObject);

var ButtonClosedStyled = (0, _styledComponents2.default)('div')(_templateObject2, function (_ref) {
    var theme = _ref.theme;
    return ' \n    button{\n        top: ' + theme.spacing.px20 + ';\n        right: ' + theme.spacing.px20 + ';\n        background: rgba(255, 255, 255, 0.8);\n        width: 35px !important;\n        height: 35px;\n        border-radius: 100%;\n    }\n';
});

var ModalStyles = (0, _styledComponents.createGlobalStyle)(_templateObject3, function (_ref2) {
    var theme = _ref2.theme,
        mobileFullScreen = _ref2.mobileFullScreen,
        noHeader = _ref2.noHeader,
        noFooter = _ref2.noFooter;
    return ' \n    .ReactModal__Overlay--after-open {\n        background: rgba(0, 0, 0, 0.75) !important;\n        z-index: 9999;\n    }\n    .ReactModal__Content--after-open {\n        max-height: 90vh;\n        max-width: 90%;\n        box-sizing: border-box;\n        padding: 0 !important;\n        ' + (noHeader && noFooter ? 'border: 0 !important;' : '') + '\n        \n        ' + (mobileFullScreen && '\n            @media screen and (max-width: ' + theme.breakpoint.md + '){\n                max-height: 100vh;\n                max-width: 100.5vw;\n                height: 100vh;\n                width: 100.5vw !important;\n                border-radius: 0 !important;\n                border: 0 !important;\n                footer {\n                    position: fixed;\n                    bottom: 0;\n                    width: 100%;\n                    box-sizing: border-box;\n                    display: flex;\n                    justify-content: space-around;\n                }\n            }\n        ') + '\n    }\n';
});

var ModalHeader = (0, _styledComponents2.default)('header')(_templateObject3, function (_ref3) {
    var theme = _ref3.theme;
    return '\n    padding: ' + theme.spacing.px24 + ' ' + theme.spacing.px70 + ' ' + theme.spacing.px24 + ' ' + theme.spacing.px30 + ';\n    border-bottom: 1px solid ' + theme.colors.grey2 + ';\n';
});

var ModalBody = (0, _styledComponents2.default)('div')(_templateObject3, function (_ref4) {
    var theme = _ref4.theme,
        mobileFullScreen = _ref4.mobileFullScreen;
    return '\n    display: block;\n    ' + (mobileFullScreen && '\n        @media screen and (max-width: ' + theme.breakpoint.md + '){\n            height: 70vh;\n        }\n    ') + '\n';
});

var ModalFooter = (0, _styledComponents2.default)('footer')(_templateObject3, function (_ref5) {
    var theme = _ref5.theme;
    return '\n    padding: ' + theme.spacing.px24 + ' ' + theme.spacing.px30 + ';\n    border-top: 1px solid ' + theme.colors.grey2 + ';\n    display: flex;\n    justify-content: flex-end;\n    align-items: stretch;\n    @media screen and (max-width: 400px) {\n        flex-direction: column;\n        justify-content: center;\n        align-items: stretch;\n        & > button:first-child {\n            margin-bottom: ' + theme.spacing.px15 + ';\n        }\n    }\n';
});

var ModalDefault = function ModalDefault(_ref6) {
    var title = _ref6.title,
        visible = _ref6.visible,
        iconClose = _ref6.iconClose,
        mobileFullScreen = _ref6.mobileFullScreen,
        closeButtonStyled = _ref6.closeButtonStyled,
        width = _ref6.width,
        buttonConfirmDisabled = _ref6.buttonConfirmDisabled,
        buttonConfirmColor = _ref6.buttonConfirmColor,
        buttonCancelDisabled = _ref6.buttonCancelDisabled,
        onClickAway = _ref6.onClickAway,
        cancelButton = _ref6.cancelButton,
        confirmButton = _ref6.confirmButton,
        cancelButtonText = _ref6.cancelButtonText,
        confirmButtonText = _ref6.confirmButtonText,
        noHeader = _ref6.noHeader,
        noFooter = _ref6.noFooter,
        children = _ref6.children;
    return _react2.default.createElement(
        _styledComponents.ThemeProvider,
        { theme: _theme.theme },
        _react2.default.createElement(
            _reactModal2.default,
            {
                ariaHideApp: false,
                isOpen: visible,
                onRequestClose: onClickAway,
                style: {
                    content: {
                        width: width,
                        top: '50%',
                        left: '50%',
                        right: 'auto',
                        bottom: 'auto',
                        marginRight: '-50%',
                        transform: 'translate(-50%, -50%)',
                        borderRadius: '10px'
                    }
                }
            },
            _react2.default.createElement(
                ModalWrapper,
                null,
                _react2.default.createElement(
                    ButtonClosedStyled,
                    { onClick: onClickAway },
                    closeButtonStyled || _react2.default.createElement(_ButtonClose2.default, { iconClose: iconClose })
                ),
                !noHeader ? _react2.default.createElement(
                    ModalHeader,
                    null,
                    _react2.default.createElement(
                        _Title2.default,
                        { tag: 'h4', fontWeight: 'bold', color: 'grey1', marginBottom: 'none' },
                        title
                    )
                ) : null,
                _react2.default.createElement(
                    ModalBody,
                    { mobileFullScreen: mobileFullScreen },
                    children
                ),
                !noFooter ? _react2.default.createElement(
                    ModalFooter,
                    null,
                    !!cancelButton && _react2.default.createElement(
                        _Button2.default,
                        { onClick: cancelButton, underlineOnHover: true, fontColor: 'blueGrey3', disabled: buttonCancelDisabled, backgroundColor: 'white' },
                        cancelButtonText
                    ),
                    !!confirmButton && _react2.default.createElement(
                        _Button2.default,
                        { onClick: confirmButton, disabled: buttonConfirmDisabled, backgroundColor: buttonConfirmColor || 'blue2' },
                        confirmButtonText
                    )
                ) : null,
                _react2.default.createElement(ModalStyles, { noHeader: noHeader, noFooter: noFooter, mobileFullScreen: mobileFullScreen })
            )
        )
    );
};

ModalDefault.propTypes = {
    visible: _propTypes2.default.bool.isRequired,
    onClickAway: _propTypes2.default.func,
    title: _propTypes2.default.string,
    cancelButtonText: _propTypes2.default.string,
    confirmButtonText: _propTypes2.default.string,
    noHeader: _propTypes2.default.bool,
    noFooter: _propTypes2.default.bool,
    buttonConfirmDisabled: _propTypes2.default.bool,
    buttonConfirmColor: _propTypes2.default.string,
    buttonCancelDisabled: _propTypes2.default.bool,
    iconClose: _propTypes2.default.array,
    closeButtonStyled: _propTypes2.default.any

};

ModalDefault.defaultProps = {
    visible: false,
    onClickAway: function onClickAway() {},
    title: "Modal Title",
    cancelButtonText: "Cancel",
    confirmButtonText: "Confirm",
    noHeader: false,
    noFooter: false
};

exports.default = ModalDefault;