'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _theme = require('../theme');

var _Title = require('../Title/Title');

var _Title2 = _interopRequireDefault(_Title);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles


// Components


var PanelWrapper = (0, _styledComponents2.default)('section')(_templateObject, function (_ref) {
    var theme = _ref.theme,
        showBoxShadow = _ref.showBoxShadow,
        showBorder = _ref.showBorder;
    return '\n    background: ' + theme.colors.white + ';\n    border-radius: ' + theme.rounded.px10 + ';\n    display: flex;\n    justify-content: space-between;\n    align-items: stretch;\n    flex-direction: column;\n    width: ' + theme.spacing.full + ';\n    height: ' + theme.spacing.full + ';\n    box-sizing: border-box;\n    ' + (showBoxShadow ? 'box-shadow: ' + theme.spacing.none + ' ' + theme.spacing.px10 + ' ' + theme.spacing.px30 + ' ' + theme.colors.grey2 + ';' : "") + '\n    ' + (showBorder ? 'border: 2px solid ' + theme.colors.grey2 + ';' : "") + '\n';
});

var PanelHeader = (0, _styledComponents2.default)('div')(_templateObject, function (_ref2) {
    var theme = _ref2.theme;
    return '\n    padding: ' + theme.spacing.px24 + ' ' + theme.spacing.px24 + ' ' + theme.spacing.none + ';\n';
});

var PanelSubtitle = (0, _styledComponents2.default)('h5')(_templateObject, function (_ref3) {
    var theme = _ref3.theme,
        subtitleColor = _ref3.subtitleColor;
    return '\n    font-weight: ' + theme.fontWeight.light + ';\n    color: ' + theme.colors[subtitleColor] + ';\n';
});

var PanelContent = (0, _styledComponents2.default)('div')(_templateObject, function (_ref4) {
    var theme = _ref4.theme;
    return '\n    margin: ' + theme.spacing.none + ';\n    display: flex;\n    justify-content: center;\n    align-items: center;\n    flex-basis: ' + theme.spacing.full + ';\n    padding: ' + theme.spacing.px30 + ' ' + theme.spacing.none + ';\n    transition: all 0.5s ease;\n';
});

var Panel = function Panel(_ref5) {
    var title = _ref5.title,
        subtitle = _ref5.subtitle,
        subtitleColor = _ref5.subtitleColor,
        children = _ref5.children,
        showBoxShadow = _ref5.showBoxShadow,
        showBorder = _ref5.showBorder;
    return _react2.default.createElement(
        _styledComponents.ThemeProvider,
        { theme: _theme.theme },
        _react2.default.createElement(
            PanelWrapper,
            { showBoxShadow: showBoxShadow, showBorder: showBorder },
            !!title || !!subtitle ? _react2.default.createElement(
                PanelHeader,
                null,
                !!title ? _react2.default.createElement(
                    _Title2.default,
                    {
                        tag: 'h2',
                        color: 'grey1',
                        fontWeight: '700',
                        marginBottom: 'px3'
                    },
                    title
                ) : null,
                subtitle ? _react2.default.createElement(
                    PanelSubtitle,
                    { subtitleColor: subtitleColor },
                    subtitle
                ) : null
            ) : null,
            _react2.default.createElement(
                PanelContent,
                null,
                children
            )
        )
    );
};

Panel.propTypes = {
    title: _propTypes2.default.string,
    subtitleColor: _propTypes2.default.string,
    children: _propTypes2.default.node,
    showBoxShadow: _propTypes2.default.bool,
    showBorder: _propTypes2.default.bool
};

Panel.defaultProps = {
    subtitle: "",
    showBoxShadow: true,
    showBorder: false
};

exports.default = Panel;