'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n    ', '\n'], ['\n    ', '\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _rcProgress = require('rc-progress');

var _theme = require('../theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles


var ProgressWrapper = (0, _styledComponents2.default)('div')(_templateObject, function (_ref) {
  var theme = _ref.theme,
      height = _ref.height;
  return '\n        display: flex;\n        align-items: center;\n        width: ' + theme.spacing.full + ';\n        height: ' + (height || '20px') + ';\n        overflow: hidden;\n        border-radius: ' + theme.rounded.px10 + ';\n        & > svg {\n            width: ' + theme.spacing.full + ';\n        }\n    ';
});

var ProgressBar = function ProgressBar(_ref2) {
  var percentage = _ref2.percentage,
      color = _ref2.color,
      height = _ref2.height;
  return _react2.default.createElement(
    _styledComponents.ThemeProvider,
    { theme: _theme.theme },
    _react2.default.createElement(
      ProgressWrapper,
      { height: height },
      _react2.default.createElement(_rcProgress.Line, { percent: percentage, strokeWidth: '3', trailWidth: '3', strokeColor: color })
    )
  );
};

ProgressBar.propTypes = {
  percentage: _propTypes2.default.number
};

ProgressBar.defaultProps = {
  percentage: 0,
  color: '#187db5'
};

exports.default = ProgressBar;