'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _theme = require('../theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles


var LabelRadio = (0, _styledComponents2.default)('label')(_templateObject, function (_ref) {
    var theme = _ref.theme;
    return '\n    font-size: ' + theme.fontSize.px16 + ';\n    display: flex;\n    align-items: center;\n    padding-bottom: 10px;\n    position: relative;\n    cursor: pointer;\n    line-height: 1;\n    &::before {\n        content: \'\';\n        position: absolute;\n        border: 2px solid #ffffff;\n        width: 10px;\n        height: 10px;\n        border-radius: 100%;\n        left: 2px;\n        top: 2px;\n    }\n';
});

var InputRadio = (0, _styledComponents2.default)('input')(_templateObject, function (_ref2) {
    var theme = _ref2.theme;
    return '\n    margin: ' + theme.spacing.none + ' ' + theme.spacing.px10 + ' ' + theme.spacing.none + ' ' + theme.spacing.none + ';\n    width: 18px;\n    height: 18px;\n    appearance: none;\n    border: 2px solid ' + theme.colors.blue2 + ';\n    border-radius: ' + theme.rounded.full + ';\n    outline: none;\n    &:checked {\n        background: ' + theme.colors.blue2 + ';\n    }\n';
});

var Radio = function Radio(props) {
    return _react2.default.createElement(
        _styledComponents.ThemeProvider,
        { theme: _theme.theme },
        _react2.default.createElement(
            LabelRadio,
            { htmlFor: props.id },
            _react2.default.createElement(InputRadio, _extends({ id: props.id, type: 'radio', value: props.value, name: props.name, ref: props.innerRef }, props)),
            props.text
        )
    );
};

Radio.propTypes = {
    id: _propTypes2.default.node,
    value: _propTypes2.default.node,
    name: _propTypes2.default.string,
    text: _propTypes2.default.string
};

Radio.defaultProps = {
    text: "Text"
};

exports.default = Radio;