'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _theme = require('../theme');

var _reactFontawesome = require('@fortawesome/react-fontawesome');

var _freeSolidSvgIcons = require('@fortawesome/free-solid-svg-icons');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles


// Icons


var SelectWrapper = (0, _styledComponents2.default)('div')(_templateObject, function (_ref) {
    var theme = _ref.theme,
        withoutBorder = _ref.withoutBorder,
        withBorder = _ref.withBorder;
    return '\n    border: none;\n    display: inline-block;\n    position: relative;\n    overflow: hidden;\n    min-width: 180px;\n    border-radius: ' + theme.rounded.px10 + ';\n    ' + (withoutBorder && 'border: none;' || withBorder && 'border: 1px solid ' + theme.colors.grey2 + '; width: ' + theme.spacing.full + ';' || 'border-bottom: 1px solid ' + theme.colors.grey2 + '; width: ' + theme.spacing.full + '; ') + '\n    \n';
});

var SelectStyled = (0, _styledComponents2.default)('select')(_templateObject, function (_ref2) {
    var theme = _ref2.theme,
        disabled = _ref2.disabled,
        size = _ref2.size;
    return '\n    width: ' + theme.spacing.full + ';\n    \n    background: none;\n    outline: none;\n    border: none;\n    appearance: none;\n    -webkit-appearance: none;\n    position: relative;\n    z-index: 1;\n    height: auto;\n    font-size: ' + theme.fontSize.px16 + ';\n    padding: 10px 40px 10px 12px;\n    ' + (size === "px14" ? '\n        font-size: ' + theme.fontSize.px14 + ';\n        padding: 5px 30px 5px 10px;\n        ' : '') + '\n    + svg {\n        width: ' + theme.spacing.px25 + ';\n        height: ' + theme.spacing.px25 + ';    \n        right: ' + theme.spacing.px10 + ';\n        top: ' + theme.spacing.px5 + ';\n        fill: ' + theme.colors.grey2 + ';\n        position: absolute;\n        z-index: 0;\n        ' + (size === "px14" ? '\n            width: ' + theme.spacing.px15 + ';\n            height: ' + theme.spacing.px15 + ';\n            top: ' + theme.spacing.px5 + ';\n            ' : '') + '\n    }\n    ' + (disabled ? 'cursor: not-allowed;' : 'cursor: pointer;') + '\n';
});

var Select = function Select(_ref3, props) {
    var onChange = _ref3.onChange,
        selectValue = _ref3.selectValue,
        children = _ref3.children,
        withoutBorder = _ref3.withoutBorder,
        withBorder = _ref3.withBorder,
        disabled = _ref3.disabled,
        size = _ref3.size,
        defaultValue = _ref3.defaultValue;
    return _react2.default.createElement(
        _styledComponents.ThemeProvider,
        { theme: _theme.theme },
        _react2.default.createElement(
            SelectWrapper,
            _extends({ withoutBorder: withoutBorder, withBorder: withBorder }, props),
            _react2.default.createElement(
                SelectStyled,
                { size: size, onChange: onChange, value: selectValue, defaultValue: defaultValue, disabled: disabled },
                children
            ),
            _react2.default.createElement(_reactFontawesome.FontAwesomeIcon, { icon: _freeSolidSvgIcons.faChevronDown })
        )
    );
};

Select.propTypes = {
    disabled: _propTypes2.default.bool
};

Select.defaultProps = {
    disabled: false
};

exports.default = Select;