'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']),
    _templateObject2 = _taggedTemplateLiteral(['\n    margin-bottom: 14px;\n'], ['\n    margin-bottom: 14px;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _reactFontawesome = require('@fortawesome/react-fontawesome');

var _theme = require('../theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

// Icons


// Styles


var ListTableHeader = (0, _styledComponents2.default)('div')(_templateObject, function (_ref) {
    var theme = _ref.theme;
    return '\n    display: flex;\n    margin-bottom: ' + theme.spacing.px10 + ';\n    @media screen and (max-width: ' + theme.breakpoint.lg + '){\n        display: none;\n    }\n';
});

var ListTableHeaderItem = (0, _styledComponents2.default)('div')(_templateObject, function (_ref2) {
    var theme = _ref2.theme,
        columnWidth = _ref2.columnWidth,
        buttonAction = _ref2.buttonAction,
        removeCursorPointer = _ref2.removeCursorPointer;
    return '\n    width: ' + columnWidth + '%;\n    padding: ' + theme.spacing.none + ' ' + theme.spacing.px10 + ';\n    color: ' + theme.colors.blueGrey2 + ';\n    font-size: ' + theme.fontSize.px14 + ';\n    display: flex;\n    justify-content: flex-start;\n    overflow: hidden;\n    text-overflow: ellipsis;\n    text-transform: none;\n    cursor: pointer;\n    box-sizing: border-box;\n    color: ' + theme.colors.blue2 + ';\n    & > span {\n        width: initial;\n    }\n    ' + (buttonAction ? '\n        text-align: center;\n        justify-content: center;\n        ' : '') + '\n    ' + (removeCursorPointer ? '\n        cursor: initial;\n        ' : '') + '\n';
});

var ContainerPadding = (0, _styledComponents2.default)('div')(_templateObject2);

var TableRow = (0, _styledComponents2.default)('div')(_templateObject, function (_ref3) {
    var theme = _ref3.theme,
        firstItem = _ref3.firstItem,
        color = _ref3.color,
        lastItem = _ref3.lastItem;
    return '\n    background-color: ' + theme.colors.white + ';\n    border-bottom: 2px solid ' + theme.colors.grey2 + ';\n    box-shadow: 2px 17px 18px -24px rgba(0,0,0,.3);\n    display: flex;\n    border-left: 4px solid ' + color + ';\n    position: relative;\n    @media screen and (max-width: ' + theme.breakpoint.lg + '){\n        flex-direction: column;\n        align-items: center;\n        box-shadow: 0 0 20px rgba(0,0,0,.2);\n        border-radius: 10px !important;\n        margin: 30px 0;\n        border-left: 0;\n    }\n    ' + (firstItem ? '\n        border-top-left-radius: 10px;\n        border-top-right-radius: 10px;\n        border-top: none;\n    ' : '') + '\n\n    ' + (lastItem ? '\n        border-bottom-left-radius: 10px;\n        border-bottom-right-radius: 10px;\n        border-bottom: none;\n    ' : '') + '\n';
});
var TableRowItem = (0, _styledComponents2.default)('div')(_templateObject, function (_ref4) {
    var theme = _ref4.theme,
        columnWidth = _ref4.columnWidth,
        firstItem = _ref4.firstItem,
        buttonAction = _ref4.buttonAction,
        noDivider = _ref4.noDivider;
    return '\n    padding: ' + theme.spacing.px15 + ' ' + theme.spacing.px10 + ';\n    width: ' + columnWidth + '%;\n    text-align: left;\n    justify-content: center;\n    flex-direction: column;\n    display: flex;\n    box-sizing: border-box;\n    overflow: hidden;\n    text-overflow: ellipsis;\n    border-left: 1px solid ' + theme.colors.grey1 + ';\n    \n    font-size: ' + theme.fontSize.px14 + ';\n    color: ' + theme.colors.blueGrey2 + ';\n    \n    @media screen and (max-width: ' + theme.breakpoint.lg + '){\n        width: 100%;\n        align-items: center;\n        border-top: 1px solid ' + theme.colors.grey2 + ';\n        padding: ' + theme.spacing.px0 + ' ' + theme.spacing.px20 + ' 0 0;\n        flex-direction: row;\n        justify-content: space-between;\n        border-left: 0;\n        :first-child  {\n            border-top: 0;\n        }\n        p {\n            font-size: ' + theme.fontSize.px16 + ';\n        }\n        ' + (buttonAction ? 'max-width: none;' : '') + '\n    }\n    ' + (firstItem || noDivider ? '\n        border-left: 0;\n    ' : '') + '\n\n    ' + (buttonAction ? '\n        text-align: center;\n        cursor: pointer;\n        overflow: visible;\n    ' : '') + '\n';
});

var IconStyled = (0, _styledComponents2.default)('div')(_templateObject, function (_ref5) {
    var theme = _ref5.theme;
    return '\n    color: ' + theme.colors.blueGrey2 + ';\n    font-size: ' + theme.fontSize.px18 + ';\n    width: 22px;\n    height: 22px;\n    margin-left: auto;\n    margin-right: auto;\n    border-radius: 50%;\n    transition: background 0.3s;\n    &:hover{\n        background: #f2f2f2 radial-gradient(circle, transparent 1%, #f2f2f2 1%) center/15000%;\n    }\n    &:active {\n        background-color: #cecece;\n        background-size: 100%;\n        transition: background 0s;\n    }\n';
});

var ActionButton = (0, _styledComponents2.default)('div')(_templateObject, function (_ref6) {
    var theme = _ref6.theme;
    return '\n    @media screen and (max-width: ' + theme.breakpoint.lg + '){\n        display: flex;\n        flex-direction: column;\n    }\n';
});

var ActionStyled = (0, _styledComponents2.default)('span')(_templateObject, function (_ref7) {
    var theme = _ref7.theme;
    return '\n    text-transform: capitalize\n    color: ' + theme.colors.blueGrey3 + '\n    font-size: ' + theme.fontSize.px10 + ';\n    @media screen and (max-width: ' + theme.breakpoint.lg + '){\n        font-size: ' + theme.fontSize.px12 + ';\n        padding: ' + theme.spacing.px5 + ' 0;\n    }\n';
});

var IconOrderBy = (0, _styledComponents2.default)('span')(_templateObject, function (_ref8) {
    var theme = _ref8.theme;
    return '\n    padding-left: 8px;\n    color: ' + theme.colors.blue2 + ';\n    font-size: ' + theme.fontSize.px12 + ';\n';
});

var ColumnTitleMobile = (0, _styledComponents2.default)('div')(_templateObject, function (_ref9) {
    var theme = _ref9.theme;
    return '\n    display: none;\n    width: 15%;\n    text-overflow: ellipsis;\n    white-space: nowrap;\n    overflow: hidden;\n    min-width: 100px;\n    padding: ' + theme.spacing.px20 + ';\n    margin-right: ' + theme.spacing.px20 + ';\n    text-align: left;\n    border-right: 1px solid ' + theme.colors.grey2 + ';\n    color: ' + theme.colors.blue2 + ';\n    font-size: ' + theme.fontSize.px16 + ';\n    \n    @media screen and (max-width: ' + theme.breakpoint.lg + '){\n        display: block;\n    }\n\n';
});
var ColumnContent = (0, _styledComponents2.default)('div')(_templateObject, function (_ref10) {
    var theme = _ref10.theme;
    return '\n    @media screen and (max-width: ' + theme.breakpoint.lg + '){\n        display: flex;\n        align-items: center;\n        justify-content: flex-start;\n    }\n';
});

function Table(props) {
    var headers = props.headers,
        actionPositions = props.actionPositions,
        data = props.data;

    var _useState = (0, _react.useState)(''),
        _useState2 = _slicedToArray(_useState, 2),
        fieldOrder = _useState2[0],
        setFieldOrder = _useState2[1];

    var _useState3 = (0, _react.useState)('desc'),
        _useState4 = _slicedToArray(_useState3, 2),
        order = _useState4[0],
        setOrder = _useState4[1];

    var _useState5 = (0, _react.useState)('sort-amount-down'),
        _useState6 = _slicedToArray(_useState5, 2),
        iconOrder = _useState6[0],
        setIconOrder = _useState6[1];

    var _useState7 = (0, _react.useState)([]),
        _useState8 = _slicedToArray(_useState7, 2),
        globalData = _useState8[0],
        setGlobalData = _useState8[1];

    var _useState9 = (0, _react.useState)(0),
        _useState10 = _slicedToArray(_useState9, 2),
        columnWidth = _useState10[0],
        setColumnWidth = _useState10[1];

    (0, _react.useEffect)(function () {
        setFieldOrder(headers[0]);
    }, []);

    (0, _react.useEffect)(function () {
        if (data.length) {
            orderBy(headers[0]);
            setGlobalData(data);
            updateColumnWidth();
        }
    }, [data]);

    var updateColumnWidth = function updateColumnWidth() {
        var totalWidthSetted = 0;
        var totalItemsWithWidthSetted = 0;
        if (globalData.length) {
            Object.entries(globalData[0]).forEach(function (item) {
                if (item[1]['width']) {
                    totalWidthSetted += item[1]['width'];
                    totalItemsWithWidthSetted++;
                }
            });
        }

        var newColumnWidth = (100 - totalWidthSetted) / (headers.length - totalItemsWithWidthSetted);

        newColumnWidth = newColumnWidth < 10 ? 10 : newColumnWidth;

        setColumnWidth(newColumnWidth);
    };

    var orderBy = function orderBy(field) {
        var data = globalData.sort(function (a, b) {
            var curr = a[field].originalValue !== undefined ? a[field].originalValue : a[field].value;
            var next = b[field].originalValue !== undefined ? b[field].originalValue : b[field].value;

            if (order === 'asc') {
                return curr < next ? -1 : curr > next ? 1 : 0;
            }
            return curr > next ? -1 : curr < next ? 1 : 0;
        });

        setOrder(order === 'desc' ? 'asc' : 'desc');
        setGlobalData(data);
        setFieldOrder(field);
        setIconOrder(order === 'desc' ? 'sort-amount-up' : 'sort-amount-down');
    };

    return globalData.length ? _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement(
            _styledComponents.ThemeProvider,
            { theme: _theme.theme },
            _react2.default.createElement(
                ListTableHeader,
                null,
                headers.map(function (item, index) {
                    var isAction = actionPositions.some(function (item) {
                        return item === index;
                    });
                    var width = globalData.length && globalData[0][item] && globalData[0][item].width || columnWidth;
                    var removeTitle = globalData.length && globalData[0][item] && globalData[0][item].noTitle;
                    var noSort = globalData.length && globalData[0][item] && globalData[0][item].noSort;

                    return _react2.default.createElement(
                        ListTableHeaderItem,
                        {
                            key: index,
                            buttonAction: isAction,
                            columnWidth: width,
                            removeCursorPointer: removeTitle || isAction,
                            onClick: removeTitle || noSort ? function () {} : function () {
                                return orderBy(item);
                            }
                        },
                        !removeTitle && _react2.default.createElement(
                            _react.Fragment,
                            null,
                            item,
                            item === fieldOrder && !isAction && !noSort && _react2.default.createElement(
                                IconOrderBy,
                                null,
                                _react2.default.createElement(_reactFontawesome.FontAwesomeIcon, { icon: ['fal', iconOrder] })
                            )
                        )
                    );
                })
            ),
            _react2.default.createElement(
                ContainerPadding,
                null,
                globalData.map(function (row, index, array) {
                    return _react2.default.createElement(
                        TableRow,
                        { firstItem: index === 0, lastItem: array.length - 1 === index, key: index },
                        headers.map(function (column, indexColumn, arrayColumn) {
                            var isAction = actionPositions.some(function (item) {
                                return item === indexColumn;
                            });
                            var columnInfo = row[column] || {};
                            var width = columnInfo.width || columnWidth;
                            return _react2.default.createElement(
                                TableRowItem,
                                {
                                    key: -indexColumn,
                                    firstItem: indexColumn === 0,
                                    lastItem: arrayColumn.length - 1 === indexColumn,
                                    buttonAction: isAction,
                                    columnWidth: width,
                                    noDivider: columnInfo.noDivider
                                },
                                _react2.default.createElement(
                                    ColumnTitleMobile,
                                    null,
                                    column
                                ),
                                isAction ? _react2.default.createElement(
                                    ColumnContent,
                                    null,
                                    _react2.default.createElement(
                                        ActionButton,
                                        { onClick: columnInfo.action ? columnInfo.action : function () {} },
                                        columnInfo.icon ? _react2.default.createElement(
                                            IconStyled,
                                            null,
                                            _react2.default.createElement(_reactFontawesome.FontAwesomeIcon, { icon: columnInfo.icon })
                                        ) : '',
                                        _react2.default.createElement(
                                            ActionStyled,
                                            null,
                                            columnInfo.value
                                        )
                                    )
                                ) : _react2.default.createElement(
                                    'div',
                                    null,
                                    columnInfo.value,
                                    ' '
                                )
                            );
                        })
                    );
                })
            )
        )
    ) : null;
}

Table.propTypes = {
    headers: _propTypes2.default.array,
    actionPositions: _propTypes2.default.array,
    data: _propTypes2.default.array
};

Table.defaultProps = {
    headers: [],
    actionPositions: [],
    data: []
};

exports.default = Table;

/*
    PARÂMETROS
    headers = [NomeColuna1, NomeColuna2, ..., NomeColunaN], -> Strings com o nome que será exibido na coluna
    actionPositions = [0,6,...,n], -> Number das posições das colunas que serão ações (é centralizado no meio e não tem ordenação),
    data = Um array contendo as informações que serão exibidas na tabela no seguinte formato:
            [{
                NomeDaColuna1: {
                    value: Valor -> Este valor pode ser qualquer coisa, um componente, string, number.
                    originalValue: valor -> É o valor que será utilizado para ordenar, caso o campo 'value' esteja recebendo algum valor transformado,
                    noTitle: true, -> Sem titulo na coluna
                    noDivider: true, -> sem divisor na esquerda
                    noSort: true, -> sem ordenção para a coluna
                    width: 20, -> largura da coluna
                },
                NomeDaColuna2: {
                    ...
                },
                ...
            },
            {Linha 2},
            ...
        ]
*/