'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n', ''], ['\n', '']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _theme = require('../theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // Modules


// Styles


var TitleWrapper = (0, _styledComponents2.default)('div')(_templateObject, function (_ref) {
  var theme = _ref.theme,
      separator = _ref.separator,
      marginBottom = _ref.marginBottom;
  return '\n    display: flex;\n    justify-content: space-between;\n    align-items: center;\n    max-width: ' + theme.spacing.full + ';\n    margin-bottom: ' + theme.spacing[marginBottom] + ';\n    ' + (separator ? '&::after {\n                display: block;\n                content: \'\';\n                height: 1px;\n                background: ' + theme.colors.grey2 + ';\n                flex-basis: ' + theme.spacing.full + ';\n            }' : '') + '\n    & > h1,\n    & > h2,\n    & > h3,\n    & > h4,\n    & > h5,\n    & > h6 {\n        margin: ' + theme.spacing.none + ';\n        ' + (separator ? 'white-space: nowrap;' : '') + '\n    }\n';
});

var TitleTag = function TitleTag(_ref2, props) {
  var tag = _ref2.tag,
      children = _ref2.children;
  return _react2.default.createElement(tag, props, children);
};

var TitleElement = (0, _styledComponents2.default)(TitleTag)(_templateObject, function (_ref3) {
  var theme = _ref3.theme,
      color = _ref3.color,
      fontWeight = _ref3.fontWeight,
      textAlign = _ref3.textAlign;
  return '\n    display: block;\n    margin: ' + theme.spacing.none + ';\n    color: ' + theme.colors[color] + ';\n    \n    font-weight: ' + theme.fontWeight[fontWeight] + ';\n    padding-right: ' + theme.spacing.px15 + ';\n    line-height: 1;\n    text-align: ' + textAlign + ';\n    &::first-letter{\n        text-transform: uppercase\n    };\n';
});

var TitleSpan = (0, _styledComponents2.default)('span')(_templateObject, function (_ref4) {
  var theme = _ref4.theme,
      color = _ref4.color,
      fontWeight = _ref4.fontWeight,
      textAlign = _ref4.textAlign;
  return '\n    display: block;\n    margin: ' + theme.spacing.none + ';\n    color: ' + theme.colors[color] + ';\n    \n    font-weight: ' + theme.fontWeight[fontWeight] + ';\n    padding-right: ' + theme.spacing.px15 + ';\n    line-height: 1;\n    text-align: ' + textAlign + ';\n    &::first-letter{\n        text-transform: uppercase\n    };\n';
});

var Title = function Title(_ref5) {
  var tag = _ref5.tag,
      color = _ref5.color,
      children = _ref5.children,
      separator = _ref5.separator,
      fontWeight = _ref5.fontWeight,
      marginBottom = _ref5.marginBottom,
      textAlign = _ref5.textAlign,
      dataTestId = _ref5.dataTestId;
  return _react2.default.createElement(
    _styledComponents.ThemeProvider,
    { theme: _theme.theme },
    _react2.default.createElement(
      TitleWrapper,
      { separator: separator, marginBottom: marginBottom, 'data-testid': dataTestId },
      _react2.default.createElement(
        TitleElement,
        { tag: tag },
        _react2.default.createElement(
          TitleSpan,
          { color: color, fontWeight: fontWeight, textAlign: textAlign },
          children
        )
      )
    )
  );
};

Title.propTypes = {
  tag: _propTypes2.default.string,
  children: _propTypes2.default.node,
  color: _propTypes2.default.string,
  fontWeight: _propTypes2.default.string,
  marginBottom: _propTypes2.default.string,
  separator: _propTypes2.default.bool,
  textAlign: _propTypes2.default.string
};

Title.defaultProps = {
  tag: 'h1',
  children: '',
  color: 'grey2',
  fontWeight: 'light',
  marginBottom: 'px40',
  separator: false,
  textAlign: 'left'
};

exports.default = Title;